# 第一周学习记录
虽然以前已经写过一些rust项目，但是做下练习也挺不错的，以下是对做练习时学到东西的一些总结

## 初级项目：

### rustlings

1. struct 更新语法，以前忽略了，很实用的语法糖

    ```bash
    let your_order = Order{name: String::from("Hacker in Rust"), count: 1, ..order_template};
    ```

2. 宏可以定义多个语法表达式
3. 为集合创建迭代器通常有三种方法

    ```bash
    iter(), which iterates over &T.
    iter_mut(), which iterates over &mut T.
    into_iter(), which iterates over T.
    ```

4. 自定义error只需要创建一个结构体，derive Debug trait，在impl Display和Error这两个trait就可以了

![https://s3-us-west-2.amazonaws.com/secure.notion-static.com/71ccfad1-b1c1-4197-9914-cebe93b7c85d/Untitled.png](https://s3-us-west-2.amazonaws.com/secure.notion-static.com/71ccfad1-b1c1-4197-9914-cebe93b7c85d/Untitled.png)

### [32 Rust Quizes](https://dtolnay.github.io/rust-quiz/1)

## Rust中级练习题

1. 287 寻找重复数：

   给定一个包含 n + 1 个整数的数组 nums ，其数字都在 1 到 n 之间（包括 1 和 n），可知至少存在一个重复的整数。

   假设 nums 只有 一个重复的整数 ，找出 这个重复的数 。

   你设计的解决方案必须不修改数组 nums 且只用常量级 O(1) 的额外空间。

    ```rust
    impl Solution {
    		//转化成有环链表寻找环的起点的问题
        pub fn find_duplicate(nums: Vec<i32>) -> i32 {
            let mut s = 0;
            let mut f = 0;
            loop {
                s = nums[s as usize];
                f = nums[nums[f as usize] as usize];
                if s == f { break; }
            }
            s = 0;
            while s != f {
                s = nums[s as usize];
                f = nums[f as usize];
            }
            s
        }
    }
    ```

    ```java
    class Solution {
        public int findDuplicate(int[] nums) {
            int slow = 0, fast = 0;
            do {
                slow = nums[slow];
                fast = nums[nums[fast]];
            } while (slow != fast);
            slow = 0;
            while (slow != fast) {
                slow = nums[slow];
                fast = nums[fast];
            }
            return slow;
        }
    }
    ```

   总结：

    - 这道题没想明白，看了题解做出来的，题目还是挺有意思的，竟然能够转化为链表的问题。
    - rust数组不能使用i32作为索引，在刷题时总是有点不方便。
    - 以后遇到给一个数组A[i,j]，数组内的数均 i<x<j 的这种情况，就可以考虑从链表的角度去解决问题了，
    - 这道题也可以用二分法和位运算去做